#include	"compiler.h"

#include	"htmlsub.h"
#include	"yuistr.h"

#define	HTMLLOAD_SIZE	0x0000ff00				// [hTCY
#define	NEWSHEAD_MAX	16						// ől

#define	CUTTAILSTR		"c"					// ȗ

#define	HEAD1_MAX		(46 + 48 + 1)			// wbhC + 1



static long getnews(char *dst, long dstsize, LPSTR src) {

	if (dstsize <= 1) {
		return(0);
	}

	// html̃^O폜
	htmlsub_text(src, src);

	// O̔pXy[XJbg
	yuistr_adjspace(src);

	// CɂȂRs[
	yuistr_excpy(dst, src, dstsize, CUTTAILSTR);

	if (*dst) {
		return(TRUE);
	}
	return(FALSE);
}



BOOL analyze_yui(char *filename, LPSTR buf, long bufsize) {

	LPSTR	tmp;
	long	ptr;
	long	nextp;
	int		max;
	char	newsbuf[128];

	// obt@͑H
	if (bufsize <= 1) {
		return(FALSE);
	}
	bufsize--;

	// e|m
	tmp = (LPSTR)MEMORY_ALLOC(HTMLLOAD_SIZE);
	if (!tmp) {
		return(FALSE);
	}

	// htmlt@C̃[h
	if (htmlsub_load(filename, tmp, HTMLLOAD_SIZE) == -1) {
		goto analyze_error;
	}

	// o
	ptr = yuistr_ankfindex(tmp, 0, "<!-- sakura -->");
	if (ptr == -1) {
		goto analyze_error;
	}

	// XVeLXg̏I|Cg
	{
		long tailp;
		tailp = yuistr_ankfindex(tmp, ptr, "<!-- /sakura -->");
		if (tailp != -1) {
			tmp[tailp] = '\0';
		}
	}

	// tT`
	ptr = yuistr_ankfindex(tmp, ptr, "<TABLE BORDER=");
	if (ptr == -1) {
		goto analyze_error;
	}

	// ̓tT`
	// L{TABLE^O炤
	nextp = yuistr_ankfindex(tmp, ptr+1, "<TABLE BORDER=");
	if (nextp != -1) {
		tmp[nextp] = '\0';
	}

	// t̃PcňxJbg
	nextp = yuistr_ankfindex(tmp, ptr, "</TABLE>");
	if (nextp == -1) {
		goto analyze_error;
	}
	tmp[nextp] = '\0';

	// ŁAto
	if (getnews(newsbuf, HEAD1_MAX, tmp + ptr)) {
		// 荞񂾂 o
		buf = yuistr_cpy(buf, newsbuf);
		buf = yuistr_cpy(buf, "\r\n");
	}
	ptr = nextp + 1;

	// {̃wbhCo
	for (max=0; max<NEWSHEAD_MAX-1; max++) {

		// wbhC̓
		ptr = yuistr_ankfindex(tmp, ptr, "<A NAME=");
		if (ptr == -1) {
			break;
		}

		// so
		nextp = yuistr_ankfindex(tmp, ptr, "<BR>");
		if (nextp == -1) {
			break;
		}
		tmp[nextp] = '\0';

		// 捞i񂾂j
		if (getnews(newsbuf, HEAD1_MAX, tmp + ptr)) {
			// 荞񂾂 o
			buf = yuistr_cpy(buf, newsbuf);
			buf = yuistr_cpy(buf, "\r\n");
		}

		// ̌ʒu
		ptr = nextp + 1;
	}

	// o͂镨΁c TRUE
	if (max) {
		MEMORY_FREE(tmp);
		return(TRUE);
	}

analyze_error:;
	MEMORY_FREE(tmp);
	return(FALSE);
}



